diff --git a/base/server/cms/src/com/netscape/cms/servlet/tks/TokenServlet.java b/base/server/cms/src/com/netscape/cms/servlet/tks/TokenServlet.java
index 9b0c2bc..2cca81b 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/tks/TokenServlet.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/tks/TokenServlet.java
@@ -706,31 +938,45 @@ public class TokenServlet extends CMSServlet {
         }
 
         if (status.equals("0")) {
-
-            auditMessage = CMS.getLogMessage(
-                         LOGGING_SIGNED_AUDIT_COMPUTE_SESSION_KEY_REQUEST_PROCESSED_SUCCESS,
-                        rCUID,
-                        ILogger.SUCCESS,
-                        status,
-                        agentId,
-                        isCryptoValidate ? "true" : "false",
-                        serversideKeygen ? "true" : "false",
-                        selectedToken,
-                        keyNickName);
-
+            // AC: KDF SPEC CHANGE - Log both CUID and KDD.
+            //                       Also added TKSKeyset, KeyInfo_KeyVersion, NistSP800_108KdfOnKeyVersion, NistSP800_108KdfUseCuidAsKdd
+            //                       Finally, log CUID and KDD in ASCII-HEX format, as long as special-decoded version is available.
+            String[] logParams = {  log_string_from_specialDecoded_byte_array(xCUID),                                   // CUID_decoded
+                                    log_string_from_specialDecoded_byte_array(xKDD),                                    // KDD_decoded
+                                    ILogger.SUCCESS,                                                                    // Outcome
+                                    status,                                                                             // status
+                                    agentId,                                                                            // AgentID
+                                    isCryptoValidate? "true":"false",                                                   // IsCryptoValidate
+                                    serversideKeygen? "true":"false",                                                   // IsServerSideKeygen
+                                    selectedToken,                                                                      // SelectedToken
+                                    keyNickName,                                                                        // KeyNickName
+                                    keySet,                                                                             // TKSKeyset
+                                    log_string_from_keyInfo(xkeyInfo),                                                  // KeyInfo_KeyVersion
+                                    "0x" + Integer.toHexString((int)nistSP800_108KdfOnKeyVersion & 0x000000FF),         // NistSP800_108KdfOnKeyVersion
+                                    Boolean.toString(nistSP800_108KdfUseCuidAsKdd)                                      // NistSP800_108KdfUseCuidAsKdd
+                                 };
+            auditMessage = CMS.getLogMessage(LOGGING_SIGNED_AUDIT_COMPUTE_SESSION_KEY_REQUEST_PROCESSED_SUCCESS, logParams);
         } else {
+            // AC: KDF SPEC CHANGE - Log both CUID and KDD
+            //                       Also added TKSKeyset, KeyInfo_KeyVersion, NistSP800_108KdfOnKeyVersion, NistSP800_108KdfUseCuidAsKdd
+            //                       Finally, log CUID and KDD in ASCII-HEX format, as long as special-decoded version is available.
+            String[] logParams = {  log_string_from_specialDecoded_byte_array(xCUID),                                   // CUID_decoded
+                                    log_string_from_specialDecoded_byte_array(xKDD),                                    // KDD_decoded
+                                    ILogger.FAILURE,                                                                    // Outcome
+                                    status,                                                                             // status
+                                    agentId,                                                                            // AgentID
+                                    isCryptoValidate? "true":"false",                                                   // IsCryptoValidate
+                                    serversideKeygen? "true":"false",                                                   // IsServerSideKeygen
+                                    selectedToken,                                                                      // SelectedToken
+                                    keyNickName,                                                                        // KeyNickName
+                                    keySet,                                                                             // TKSKeyset
+                                    log_string_from_keyInfo(xkeyInfo),                                                  // KeyInfo_KeyVersion
+                                    "0x" + Integer.toHexString((int)nistSP800_108KdfOnKeyVersion & 0x000000FF),         // NistSP800_108KdfOnKeyVersion
+                                    Boolean.toString(nistSP800_108KdfUseCuidAsKdd),                                     // NistSP800_108KdfUseCuidAsKdd
+                                    errorMsg                                                                            // Error
+                                 };
+            auditMessage = CMS.getLogMessage(LOGGING_SIGNED_AUDIT_COMPUTE_SESSION_KEY_REQUEST_PROCESSED_FAILURE, logParams);
 
-            auditMessage = CMS.getLogMessage(
-                         LOGGING_SIGNED_AUDIT_COMPUTE_SESSION_KEY_REQUEST_PROCESSED_FAILURE,
-                        rCUID,
-                        ILogger.FAILURE,
-                        status,
-                        agentId,
-                        isCryptoValidate ? "true" : "false",
-                        serversideKeygen ? "true" : "false",
-                        selectedToken,
-                        keyNickName,
-                        errorMsg);
         }
 
         audit(auditMessage);
@@ -768,8 +1014,22 @@ public class TokenServlet extends CMSServlet {
 
     private void processDiversifyKey(HttpServletRequest req,
             HttpServletResponse resp) throws EBaseException {
-        byte[] KeySetData, CUID, xCUID;
-        byte[] xkeyInfo, xnewkeyInfo;
+        byte[] KeySetData,KeysValues,xCUID,xKDD;  // AC: KDF SPEC CHANGE: removed duplicative 'CUID' variable and added xKDD
+
+        // AC: BUGFIX:  Record the actual parameters to DiversifyKey in the audit log.
+        String oldKeyNickName = null;
+        String newKeyNickName = null;
+
+        // AC: KDF SPEC CHANGE - new config file values (needed for symkey)
+        byte nistSP800_108KdfOnKeyVersion = (byte)0xff;
+        boolean nistSP800_108KdfUseCuidAsKdd = false;
+
+        // AC: BUGFIX for key versions higher than 09:  We need to initialize these variables in order for the compiler not to complain when we pass them to DiversifyKey.
+        byte[] xkeyInfo = null,xnewkeyInfo = null;
+
+        // AC: KDF SPEC CHANGE - flag for if there is an error reading our new setting
+        Exception missingSetting_exception = null;
+
         boolean missingParam = false;
         String errorMsg = "";
         String badParams = "";
@@ -779,6 +1039,15 @@ public class TokenServlet extends CMSServlet {
         String newMasterKeyName = req.getParameter(IRemoteRequest.TOKEN_NEW_KEYINFO);
         String oldMasterKeyName = req.getParameter(IRemoteRequest.TOKEN_KEYINFO);
         String rCUID = req.getParameter(IRemoteRequest.TOKEN_CUID);
+
+        // AC: KDF SPEC CHANGE - read new KDD parameter from TPS
+        String rKDD = req.getParameter("KDD");
+        if ((rKDD == null) || (rKDD.length() == 0)) {
+            // temporarily make it friendly before TPS change
+            CMS.debug("TokenServlet: KDD not supplied, set to CUID before TPS change");
+            rKDD = rCUID;
+        }
+
         String auditMessage = "";
 
         String keySet = req.getParameter(IRemoteRequest.TOKEN_KEYSET);
@@ -795,9 +1064,11 @@ public class TokenServlet extends CMSServlet {
                     (String) sContext.get(SessionContext.USER_ID);
         }
 
+        // AC: KDF SPEC CHANGE:  Need to log both KDD and CUID
         auditMessage = CMS.getLogMessage(
                         LOGGING_SIGNED_AUDIT_DIVERSIFY_KEY_REQUEST,
                         rCUID,
+                        rKDD,            // AC: KDF SPEC CHANGE - Log both CUID and KDD.
                         ILogger.SUCCESS,
                         agentId,
                         oldMasterKeyName,
@@ -810,6 +1081,14 @@ public class TokenServlet extends CMSServlet {
             CMS.debug("TokenServlet: processDiversifyKey(): missing request parameter: CUID");
             missingParam = true;
         }
+        
+        // AC: KDF SPEC CHANGE - read new KDD parameter from TPS
+        if ((rKDD == null) || (rKDD.length() == 0)) {
+            CMS.debug("TokenServlet: processDiversifyKey(): missing request parameter: KDD");
+            badParams += " KDD,";
+            missingParam = true;
+        }
+        
         if ((rnewKeyInfo == null) || (rnewKeyInfo.equals(""))) {
             badParams += " newKeyInfo,";
             CMS.debug("TokenServlet: processDiversifyKey(): missing request parameter: newKeyInfo");
@@ -821,6 +1100,12 @@ public class TokenServlet extends CMSServlet {
             missingParam = true;
         }
 
+        // AC: KDF SPEC CHANGE 
+        xCUID = null;       // avoid errors about non-initialization
+        xKDD = null;        // avoid errors about non-initialization
+        xkeyInfo = null;    // avoid errors about non-initialization
+        xnewkeyInfo = null; // avoid errors about non-initialization
+
         if (!missingParam) {
             xkeyInfo = com.netscape.cmsutil.util.Utils.SpecialDecode(oldMasterKeyName);
             if (xkeyInfo == null || xkeyInfo.length != 2) {
@@ -847,9 +1132,46 @@ public class TokenServlet extends CMSServlet {
                 CMS.debug("TokenServlet: Invalid CUID length");
                 missingParam = true;
             }
+
+            // AC: KDF SPEC CHANGE - read new KDD parameter from TPS
+            xKDD = com.netscape.cmsutil.util.Utils.SpecialDecode(rKDD);
+            if (xKDD == null || xKDD.length != 10) {
+                badParams += " KDD length,";
+                CMS.debug("TokenServlet: Invalid KDD length");
+                missingParam = true;
+            }
         }
         if (!missingParam) {
-            CUID = com.netscape.cmsutil.util.Utils.SpecialDecode(rCUID);
+          // CUID = com.netscape.cmsutil.util.Utils.SpecialDecode(rCUID); // AC: KDF SPEC CHANGE: Removed duplicative variable/processing.
+
+          // AC: KDF SPEC CHANGE - read new config file values (needed for symkey)
+          try{
+              nistSP800_108KdfOnKeyVersion = TokenServlet.read_setting_nistSP800_108KdfOnKeyVersion(keySet);
+              nistSP800_108KdfUseCuidAsKdd = TokenServlet.read_setting_nistSP800_108KdfUseCuidAsKdd(keySet);
+
+              // log settings read in to debug log along with xkeyInfo and xnewkeyInfo
+              CMS.debug("TokenServlet: processDiversifyKey():  xkeyInfo[0] (old) = 0x"
+                        + Integer.toHexString((int)(xkeyInfo[0]) & 0x0000000FF)
+                        + ",  xkeyInfo[1] (old) = 0x"
+                        + Integer.toHexString((int)(xkeyInfo[1]) & 0x0000000FF)
+                        + ",  xnewkeyInfo[0] = 0x"
+                        + Integer.toHexString((int)(xnewkeyInfo[0]) & 0x000000FF)
+                        + ",  xnewkeyInfo[1] = 0x"
+                        + Integer.toHexString((int)(xnewkeyInfo[1]) & 0x000000FF)
+                       );
+              CMS.debug("TokenServlet: processDiversifyKey():  Nist SP800-108 KDF will be used for key versions >= 0x"
+                        + Integer.toHexString((int)(nistSP800_108KdfOnKeyVersion) & 0x0000000FF)
+                       );
+              if (nistSP800_108KdfUseCuidAsKdd == true){
+                  CMS.debug("TokenServlet: processDiversifyKey():  Nist SP800-108 KDF (if used) will use CUID instead of KDD.");
+              }else{
+                  CMS.debug("TokenServlet: processDiversifyKey():  Nist SP800-108 KDF (if used) will use KDD.");
+              }
+          // conform to the set-an-error-flag mentality
+          }catch(Exception e){
+              missingSetting_exception = e;
+              CMS.debug("TokenServlet: processDiversifyKey():  Exception reading Nist SP800-108 KDF config values: " + e.toString());
+          }
 
             if (mKeyNickName != null)
                 oldMasterKeyName = mKeyNickName;
@@ -859,7 +1181,6 @@ public class TokenServlet extends CMSServlet {
             String oldKeyInfoMap = "tks." + keySet + ".mk_mappings." + req.getParameter(IRemoteRequest.TOKEN_KEYINFO); //#xx#xx
             String oldMappingValue = CMS.getConfigStore().getString(oldKeyInfoMap, null);
             String oldSelectedToken = null;
-            String oldKeyNickName = null;
             if (oldMappingValue == null) {
                 oldSelectedToken = CMS.getConfigStore().getString("tks.defaultSlot", "internal");
                 oldKeyNickName = req.getParameter(IRemoteRequest.TOKEN_KEYINFO);
@@ -872,7 +1193,6 @@ public class TokenServlet extends CMSServlet {
             String newKeyInfoMap = "tks.mk_mappings." + rnewKeyInfo; //#xx#xx
             String newMappingValue = CMS.getConfigStore().getString(newKeyInfoMap, null);
             String newSelectedToken = null;
-            String newKeyNickName = null;
             if (newMappingValue == null) {
                 newSelectedToken = CMS.getConfigStore().getString("tks.defaultSlot", "internal");
                 newKeyNickName = rnewKeyInfo;
@@ -888,10 +1208,20 @@ public class TokenServlet extends CMSServlet {
                     newKeyNickName);
 
             byte kekKeyArray[] =
-                    com.netscape.cmsutil.util.Utils.SpecialDecode(sconfig.getString("tks." + keySet + ".kek_key"));
+                com.netscape.cmsutil.util.Utils.SpecialDecode(sconfig.getString("tks." + keySet + ".kek_key"));
+
+          // AC: KDF SPEC CHANGE - check for error reading settings
+          if (missingSetting_exception == null){
             KeySetData = SessionKey.DiversifyKey(oldSelectedToken,
                      newSelectedToken, oldKeyNickName,
-                    newKeyNickName, rnewKeyInfo, CUID, kekKeyArray, useSoftToken_s, keySet);
+                     newKeyNickName,
+                     xkeyInfo,                        // AC: KDF SPEC CHANGE - pass in old key info so symkey can make decision about which KDF version to use
+                     xnewkeyInfo,                     // AC: BUGFIX for key versions higher than 09:  We need to specialDecode keyInfo parameters before sending them into symkey!  This means the parameters must be byte[]
+                     nistSP800_108KdfOnKeyVersion,    // AC: KDF SPEC CHANGE - pass in configuration file value
+                     nistSP800_108KdfUseCuidAsKdd,    // AC: KDF SPEC CHANGE - pass in configuration file value
+                     xCUID,                           // AC: KDF SPEC CHANGE - removed duplicative 'CUID' variable and replaced with 'xCUID'
+                     xKDD,                            // AC: KDF SPEC CHANGE - pass in KDD so symkey can make decision about which value (KDD,CUID) to use
+                     kekKeyArray, useSoftToken_s, keySet);
 
             if (KeySetData == null || KeySetData.length <= 1) {
                 CMS.getLogger().log(ILogger.EV_AUDIT,
@@ -901,11 +1231,18 @@ public class TokenServlet extends CMSServlet {
 
             CMS.getLogger().log(ILogger.EV_AUDIT,
                     ILogger.S_TKS,
-                    ILogger.LL_INFO, "process DiversifyKey for CUID =" + trim(pp.toHexString(CUID))
+                  ILogger.LL_INFO,
+                  "process DiversifyKey for CUID=" +
+                     trim(pp.toHexString(xCUID)) +  // AC: KDF SPEC CHANGE:  Log both CUID and KDD
+                  ", KDD=" +
+                     trim(pp.toHexString(xKDD))
                             + ";from oldMasterKeyName=" + oldSelectedToken + ":" + oldKeyNickName
                             + ";to newMasterKeyName=" + newSelectedToken + ":" + newKeyNickName);
 
             resp.setContentType("text/html");
+
+          } // AC: KDF SPEC CHANGE - endif no error reading settings from settings file
+
         } // ! missingParam
 
         //CMS.debug("TokenServlet:processDiversifyKey " +outputString);
@@ -918,6 +1255,11 @@ public class TokenServlet extends CMSServlet {
             value = IRemoteRequest.RESPONSE_STATUS+"=0&" + IRemoteRequest.TKS_RESPONSE_KeySetData+"=" +
                      com.netscape.cmsutil.util.Utils.SpecialEncode(KeySetData);
             CMS.debug("TokenServlet:process DiversifyKey.encode " + value);
+        // AC: KDF SPEC CHANGE - check for settings file issue (flag)
+        } else if (missingSetting_exception != null){
+            status = "6";
+            errorMsg = "Problem reading required configuration value.";
+            value = "status=" + status;
         } else if (missingParam) {
             status = "3";
             if (badParams.endsWith(",")) {
@@ -945,26 +1287,48 @@ public class TokenServlet extends CMSServlet {
 
         if (status.equals("0")) {
 
-            auditMessage = CMS.getLogMessage(
-                         LOGGING_SIGNED_AUDIT_DIVERSIFY_KEY_REQUEST_PROCESSED_SUCCESS,
-                        rCUID,
-                        ILogger.SUCCESS,
-                        status,
-                        agentId,
-                        oldMasterKeyName,
-                        newMasterKeyName);
-
+                // AC: KDF SPEC CHANGE - Log both CUID and KDD
+                //                       Also added TKSKeyset, OldKeyInfo_KeyVersion, NewKeyInfo_KeyVersion, NistSP800_108KdfOnKeyVersion, NistSP800_108KdfUseCuidAsKdd
+                //                       Finally, log CUID and KDD in ASCII-HEX format, as long as special-decoded version is available.
+                String[] logParams = {  log_string_from_specialDecoded_byte_array(xCUID),                               // CUID_decoded
+                                        log_string_from_specialDecoded_byte_array(xKDD),                                // KDD_decoded
+                                        ILogger.SUCCESS,                                                                // Outcome
+                                        status,                                                                         // status
+                                        agentId,                                                                        // AgentID
+
+                                        // AC: BUGFIX:  Record the actual parameters to DiversifyKey in the audit log.
+                                        oldKeyNickName,                                                                 // oldMasterKeyName
+                                        newKeyNickName,                                                                 // newMasterKeyName
+
+                                        keySet,                                                                         // TKSKeyset
+                                        log_string_from_keyInfo(xkeyInfo),                                              // OldKeyInfo_KeyVersion
+                                        log_string_from_keyInfo(xnewkeyInfo),                                           // NewKeyInfo_KeyVersion
+                                        "0x" + Integer.toHexString((int)nistSP800_108KdfOnKeyVersion & 0x000000FF),     // NistSP800_108KdfOnKeyVersion
+                                        Boolean.toString(nistSP800_108KdfUseCuidAsKdd)                                  // NistSP800_108KdfUseCuidAsKdd
+                                     };
+                auditMessage = CMS.getLogMessage(LOGGING_SIGNED_AUDIT_DIVERSIFY_KEY_REQUEST_PROCESSED_SUCCESS, logParams);
         } else {
-
-            auditMessage = CMS.getLogMessage(
-                         LOGGING_SIGNED_AUDIT_DIVERSIFY_KEY_REQUEST_PROCESSED_FAILURE,
-                        rCUID,
-                        ILogger.FAILURE,
-                        status,
-                        agentId,
-                        oldMasterKeyName,
-                        newMasterKeyName,
-                        errorMsg);
+                // AC: KDF SPEC CHANGE - Log both CUID and KDD
+                //                       Also added TKSKeyset, OldKeyInfo_KeyVersion, NewKeyInfo_KeyVersion, NistSP800_108KdfOnKeyVersion, NistSP800_108KdfUseCuidAsKdd
+                //                       Finally, log CUID and KDD in ASCII-HEX format, as long as special-decoded version is available.
+                String[] logParams = {  log_string_from_specialDecoded_byte_array(xCUID),                               // CUID_decoded
+                                        log_string_from_specialDecoded_byte_array(xKDD),                                // KDD_decoded
+                                        ILogger.FAILURE,                                                                // Outcome
+                                        status,                                                                         // status
+                                        agentId,                                                                        // AgentID
+
+                                        // AC: BUGFIX:  Record the actual parameters to DiversifyKey in the audit log.
+                                        oldKeyNickName,                                                                 // oldMasterKeyName
+                                        newKeyNickName,                                                                 // newMasterKeyName
+
+                                        keySet,                                                                         // TKSKeyset
+                                        log_string_from_keyInfo(xkeyInfo),                                              // OldKeyInfo_KeyVersion
+                                        log_string_from_keyInfo(xnewkeyInfo),                                           // NewKeyInfo_KeyVersion
+                                        "0x" + Integer.toHexString((int)nistSP800_108KdfOnKeyVersion & 0x000000FF),     // NistSP800_108KdfOnKeyVersion
+                                        Boolean.toString(nistSP800_108KdfUseCuidAsKdd),                                 // NistSP800_108KdfUseCuidAsKdd
+                                        errorMsg                                                                        // Error
+                                     };
+                auditMessage = CMS.getLogMessage(LOGGING_SIGNED_AUDIT_DIVERSIFY_KEY_REQUEST_PROCESSED_FAILURE, logParams);
         }
 
         audit(auditMessage);
@@ -972,7 +1336,15 @@ public class TokenServlet extends CMSServlet {
 
     private void processEncryptData(HttpServletRequest req,
             HttpServletResponse resp) throws EBaseException {
-        byte[] keyInfo, CUID, xCUID, encryptedData, xkeyInfo;
+        byte[] keyInfo, xCUID, encryptedData, xkeyInfo, xKDD;  // AC: KDF SPEC CHANGE: removed duplicative 'CUID' variable and added xKDD
+
+        // AC: KDF SPEC CHANGE - new config file values (needed for symkey)
+        byte nistSP800_108KdfOnKeyVersion = (byte)0xff;
+        boolean nistSP800_108KdfUseCuidAsKdd = false;
+
+        // AC: KDF SPEC CHANGE - flag for if there is an error reading our new setting
+        Exception missingSetting_exception = null;
+
         boolean missingParam = false;
         byte[] data = null;
         boolean isRandom = true; // randomly generate the data to be encrypted
@@ -984,6 +1356,15 @@ public class TokenServlet extends CMSServlet {
         String rdata = req.getParameter(IRemoteRequest.TOKEN_DATA);
         String rKeyInfo = req.getParameter(IRemoteRequest.TOKEN_KEYINFO);
         String rCUID = req.getParameter(IRemoteRequest.TOKEN_CUID);
+
+        // AC: KDF SPEC CHANGE - read new KDD parameter from TPS
+        String rKDD = req.getParameter("KDD");
+        if ((rKDD == null) || (rKDD.length() == 0)) {
+            // temporarily make it friendly before TPS change
+            CMS.debug("TokenServlet: KDD not supplied, set to CUID before TPS change");
+            rKDD = rCUID;
+        }
+
         String keySet = req.getParameter(IRemoteRequest.TOKEN_KEYSET);
         if (keySet == null || keySet.equals("")) {
             keySet = "defKeySet";
@@ -1008,9 +1389,11 @@ public class TokenServlet extends CMSServlet {
             isRandom = true;
         }
 
+        // AC: KDF SPEC CHANGE:  Need to log both KDD and CUID
         String auditMessage = CMS.getLogMessage(
                        LOGGING_SIGNED_AUDIT_ENCRYPT_DATA_REQUEST,
                        rCUID,
+                       rKDD,            // AC: KDF SPEC CHANGE - Log both CUID and KDD.
                        ILogger.SUCCESS,
                        agentId,
                        s_isRandom);
@@ -1044,12 +1427,24 @@ public class TokenServlet extends CMSServlet {
             missingParam = true;
         }
 
+        // AC: KDF SPEC CHANGE - read new KDD parameter from TPS
+        if ((rKDD == null) || (rKDD.length() == 0)) {
+            CMS.debug("TokenServlet: processDiversifyKey(): missing request parameter: KDD");
+            badParams += " KDD,";
+            missingParam = true;
+        }
+
         if ((rKeyInfo == null) || (rKeyInfo.equals(""))) {
             badParams += " KeyInfo,";
             CMS.debug("TokenServlet: processEncryptData(): missing request parameter: key info");
             missingParam = true;
         }
 
+        // AC: KDF SPEC CHANGE
+        xCUID = null;       // avoid errors about non-initialization
+        xKDD = null;        // avoid errors about non-initialization
+        xkeyInfo = null;    // avoid errors about non-initialization
+
         if (!missingParam) {
             xCUID = com.netscape.cmsutil.util.Utils.SpecialDecode(rCUID);
             if (xCUID == null || xCUID.length != 10) {
@@ -1057,6 +1452,15 @@ public class TokenServlet extends CMSServlet {
                 CMS.debug("TokenServlet: Invalid CUID length");
                 missingParam = true;
             }
+
+            // AC: KDF SPEC CHANGE - read new KDD parameter from TPS
+            xKDD = com.netscape.cmsutil.util.Utils.SpecialDecode(rKDD);
+            if (xKDD == null || xKDD.length != 10) {
+                badParams += " KDD length,";
+                CMS.debug("TokenServlet: Invalid KDD length");
+                missingParam = true;
+            }
+
             xkeyInfo = com.netscape.cmsutil.util.Utils.SpecialDecode(rKeyInfo);
             if (xkeyInfo == null || xkeyInfo.length != 2) {
                 badParams += " KeyInfo length,";
@@ -1072,10 +1476,35 @@ public class TokenServlet extends CMSServlet {
         String selectedToken = null;
         String keyNickName = null;
         if (!missingParam) {
+
+            // AC: KDF SPEC CHANGE - read new config file values (needed for symkey
+            try{
+                nistSP800_108KdfOnKeyVersion = TokenServlet.read_setting_nistSP800_108KdfOnKeyVersion(keySet);
+                nistSP800_108KdfUseCuidAsKdd = TokenServlet.read_setting_nistSP800_108KdfUseCuidAsKdd(keySet);
+
+                // log settings read in to debug log along with xkeyInfo
+                CMS.debug("TokenServlet: processEncryptData():  xkeyInfo[0] = 0x"
+                          + Integer.toHexString((int)(xkeyInfo[0]) & 0x0000000FF)
+                          + ",  xkeyInfo[1] = 0x"
+                          + Integer.toHexString((int)(xkeyInfo[1]) & 0x0000000FF)
+                         );
+                CMS.debug("TokenServlet: processEncryptData():  Nist SP800-108 KDF will be used for key versions >= 0x"
+                          + Integer.toHexString((int)(nistSP800_108KdfOnKeyVersion) & 0x0000000FF)
+                         );
+                if (nistSP800_108KdfUseCuidAsKdd == true){
+                    CMS.debug("TokenServlet: processEncryptData():  Nist SP800-108 KDF (if used) will use CUID instead of KDD.");
+                }else{
+                    CMS.debug("TokenServlet: processEncryptData():  Nist SP800-108 KDF (if used) will use KDD.");
+                }
+            // conform to the set-an-error-flag mentality
+            }catch(Exception e){
+                missingSetting_exception = e;
+                CMS.debug("TokenServlet: processEncryptData():  Exception reading Nist SP800-108 KDF config values: " + e.toString());
+            }
+
             if (!isRandom)
                 data = com.netscape.cmsutil.util.Utils.SpecialDecode(rdata);
             keyInfo = com.netscape.cmsutil.util.Utils.SpecialDecode(rKeyInfo);
-            CUID = com.netscape.cmsutil.util.Utils.SpecialDecode(rCUID);
 
             String keyInfoMap = "tks." + keySet + ".mk_mappings." + rKeyInfo;
             String mappingValue = CMS.getConfigStore().getString(keyInfoMap, null);
@@ -1090,12 +1519,30 @@ public class TokenServlet extends CMSServlet {
 
             byte kekKeyArray[] =
                     com.netscape.cmsutil.util.Utils.SpecialDecode(sconfig.getString("tks." + keySet + ".kek_key"));
+          // AC: KDF SPEC CHANGE - check for error reading settings
+          if (missingSetting_exception == null){
+
             encryptedData = SessionKey.EncryptData(
-                       selectedToken, keyNickName, data, keyInfo, CUID, kekKeyArray, useSoftToken_s, keySet);
+                       selectedToken,keyNickName,data,keyInfo,
+                       nistSP800_108KdfOnKeyVersion,    // AC: KDF SPEC CHANGE - pass in configuration file value
+                       nistSP800_108KdfUseCuidAsKdd,    // AC: KDF SPEC CHANGE - pass in configuration file value
+                       xCUID,                           // AC: KDF SPEC CHANGE - removed duplicative 'CUID' variable and replaced with 'xCUID'
+                       xKDD,                            // AC: KDF SPEC CHANGE - pass in KDD so symkey can make decision about which value (KDD,CUID) to use
+                       kekKeyArray, useSoftToken_s, keySet);
+
+          // AC: KDF SPEC CHANGE - Log both CUID and KDD
+
 
             CMS.getLogger().log(ILogger.EV_AUDIT,
                      ILogger.S_TKS,
-                     ILogger.LL_INFO, "process EncryptData for CUID =" + trim(pp.toHexString(CUID)));
+                     ILogger.LL_INFO,"process EncryptData for CUID="+
+                       trim(pp.toHexString(xCUID)) +
+                       ", KDD=" +
+                       trim(pp.toHexString(xKDD)));
+
+          } // AC: KDF SPEC CHANGE - endif no error reading settings from settings file
+
+
         } // !missingParam
 
         resp.setContentType("text/html");
